var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { KaiModal } from './kai-modal';
import { customElement, html, property, css } from 'lit-element';
import './kai-button';
let KaiDialog = class KaiDialog extends KaiModal {
    constructor() {
        super(...arguments);
        this.remember = false;
    }
    static get styles() {
        return [
            ...super.styles,
            css `
        .remember-container {
          width: 100%;
          display: flex;
          justify-content: space-between;
          align-items: center;
          padding-top: 30px;
        }
      `,
        ];
    }
    onCancel() {
        const cancelEvent = new CustomEvent('dialog-cancel', {
            bubbles: true,
            composed: true,
            detail: {
                status: this.remember ? 'deny' : 'ask',
            },
        });
        this.dispatchEvent(cancelEvent);
    }
    onDone() {
        const doneEvent = new CustomEvent('dialog-done', {
            bubbles: true,
            composed: true,
            detail: {
                status: this.remember ? 'allow' : 'ask',
            },
        });
        this.dispatchEvent(doneEvent);
    }
    render() {
        return html `
      <header class="modal-title">
        <kai-text as="h3">${this.modalTitle}</kai-text>
      </header>
      <div class="modal-content">
        <slot></slot>
        <div class="remember-container">
          <kai-text slot="item-content" as="h5">
            remember-my-choice
          </kai-text>
          <kai-checkbox
            slot="item-right"
            @checkbox-change=${(e) => {
            this.remember = e.detail.checked;
        }}
          >
          </kai-checkbox>
        </div>
      </div>
      <footer class="modal-actions" style="text-align: center;">
        <kai-button @click="${this.onCancel}" secondary>
          ${this.cancelLabel}
        </kai-button>
        <kai-button @click="${this.onDone}">
          ${this.doneLabel}
        </kai-button>
      </footer>
    `;
    }
};
__decorate([
    property({ type: String, attribute: 'modal-title' })
], KaiDialog.prototype, "modalTitle", void 0);
__decorate([
    property({ type: String, attribute: 'cancel-label' })
], KaiDialog.prototype, "cancelLabel", void 0);
__decorate([
    property({ type: String, attribute: 'done-label' })
], KaiDialog.prototype, "doneLabel", void 0);
__decorate([
    property({ type: Boolean })
], KaiDialog.prototype, "remember", void 0);
KaiDialog = __decorate([
    customElement('kai-dialog')
], KaiDialog);
export { KaiDialog };
//# sourceMappingURL=kai-dialog.js.map