var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, html, css, property, LitElement } from 'lit-element';
let KaiOverlay = class KaiOverlay extends LitElement {
    constructor() {
        super(...arguments);
        this.open = false;
    }
    static get styles() {
        return css `
      :host {
        position: fixed;
        top: 0;
        left: 0;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        width: 100%;
        height: 100%;
        z-index: var(--z-index-modal);
        /* transition */
        opacity: 0;
        transform: scale(1.5);
        transition-property: transform, opacity;
        transition-timing-function: cubic-bezier(0, 0, 0, 1);
        transition-duration: 0, 0.1s;
        transition-delay: 0.1s, 0s;
        pointer-events: none;
        background-color: var(--overlay-bg);
      }

      :host([open]) {
        transition-duration: 0.18s, 0.12s;
        transform: scale(1);
        opacity: 1;
        transition-delay: 0;
        pointer-events: all;
      }
    `;
    }
    render() {
        return html `<slot></slot>`;
    }
};
__decorate([
    property({ type: Boolean })
], KaiOverlay.prototype, "open", void 0);
KaiOverlay = __decorate([
    customElement('kai-overlay')
], KaiOverlay);
export { KaiOverlay };
//# sourceMappingURL=kai-overlay.js.map