var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { html, customElement, LitElement, property } from 'lit-element';
import { DragNDropService } from '../services';
let KaiPanelList = class KaiPanelList extends LitElement {
    constructor() {
        super(...arguments);
        this.draggable = false;
        this.handleMouseMove = e => {
            const { isDragging } = DragNDropService;
            if (isDragging) {
                DragNDropService.moveItem(e);
            }
        };
        this.handleMouseLeave = e => {
            const { isDragging } = DragNDropService;
            if (isDragging) {
                this.firstElementChild.classList.remove('top');
                DragNDropService.commit();
            }
        };
    }
    firstUpdated() {
        if (this.draggable) {
            this.addEventListener('mousemove', this.handleMouseMove, false);
            this.addEventListener('mouseleave', this.handleMouseLeave, false);
        }
    }
    disconnectedCallback() {
        this.removeEventListener('mousemove', this.handleMouseMove);
        this.removeEventListener('mouseleave', this.handleMouseLeave);
    }
    updated(changes) {
        if (changes.has('draggable')) {
            if (this.draggable) {
                this.addEventListener('mousemove', this.handleMouseMove, false);
                this.addEventListener('mouseleave', this.handleMouseLeave, false);
            }
        }
    }
    render() {
        return html `
      <slot></slot>
    `;
    }
};
__decorate([
    property({ type: Boolean, reflect: true })
], KaiPanelList.prototype, "draggable", void 0);
KaiPanelList = __decorate([
    customElement('kai-panel-list')
], KaiPanelList);
export { KaiPanelList };
//# sourceMappingURL=kai-panel-list.js.map