var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, LitElement, property, css, html } from 'lit-element';
let KaiProgress = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class KaiProgress extends LitElement {
    constructor() {
        super(...arguments);
        this.type = 'default';
    }
    static get styles() {
        return css `
      :host {
        position: relative;
        width: 100%;
        height: 0.4rem;
        top: -8rem;
      }

      .track {
        position: relative;
        width: 100%;
        height: 2px;
        top: 1px;
        border-radius: 2px;
        background-color: var(--gs-20);
        z-index: 0;
      }

      :host([type='top']) > .track {
        background-color: transparent;
      }

      :host([type='indeterminate']) .first,
      :host([type='indeterminate']) .second,
      .progress {
        position: absolute;
        top: 0;
        left: 0;
        height: 4px;
        border-radius: 2px;
        background-color: var(--theme-color-primary);
        z-index: 2;
      }

      :host([type='top']) .progress {
        border-radius: 0 2px 2px 0;
      }

      :host([type='buffered']) .buffer {
        background-color: var(--gs-80);
        z-index: 1;
      }

      :host([type='indeterminate']) .first {
        animation: first 2s cubic-bezier(0.7, 0, 0.55, 1) infinite;
      }

      :host([type='indeterminate']) .second {
        animation: second 2s cubic-bezier(0, 0, 0.3, 1) infinite;
      }

      @keyframes first {
        0% {
          width: 0;
        }
        45% {
          width: 100%;
          left: 0;
        }
        90% {
          width: 0;
          left: 100%;
        }
        100% {
          width: 0;
          left: 100%;
        }
      }

      @keyframes second {
        70% {
          width: 0;
          left: 0;
        }
        84% {
          width: 56%;
          left: 0;
        }
        85% {
          width: 60%;
          left: 10%;
        }
        100% {
          width: 0;
          left: 100%;
        }
      }
    `;
    }
    get progress() {
        return this.shadowRoot.querySelector('.progress:not(.buffer)');
    }
    get buffer() {
        return this.shadowRoot.querySelector('.buffer');
    }
    updateProgress() {
        this.progress.style.width = `${this.percentage}%`;
    }
    updateBuffer() {
        this.buffer.style.width = `${this.bufferPercentage}%`;
    }
    updated(changes) {
        if (changes.has('percentage'))
            this.updateProgress();
        if (changes.has('bufferPercentage'))
            this.updateBuffer();
    }
    render() {
        return html `
      <div class="track"></div>
      ${this.type === 'buffered'
            ? html `
            <div class="progress buffer"></div>
          `
            : null}
      <div class="progress"></div>
      ${this.type === 'indeterminate'
            ? html `
            <div class="first"></div>
            <div class="second"></div>
          `
            : null}
    `;
    }
};
__decorate([
    property({ type: String })
], KaiProgress.prototype, "type", void 0);
__decorate([
    property({ type: Number })
], KaiProgress.prototype, "percentage", void 0);
__decorate([
    property({ type: Number, attribute: 'buffer-percentage' })
], KaiProgress.prototype, "bufferPercentage", void 0);
KaiProgress = __decorate([
    customElement('kai-progress')
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], KaiProgress);
export { KaiProgress };
//# sourceMappingURL=kai-progress.js.map