var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, html, property } from "lit-element";
import { KaiModal } from "./kai-modal";
import './kai-button';
import './kai-input';
let KaiPrompt = class KaiPrompt extends KaiModal {
    constructor() {
        super(...arguments);
        this.defaultValue = '';
        this.placeholder = '';
        this.maxLength = 400;
        this.isEmpty = !this.defaultValue.length;
    }
    onCancel() {
        const cancelEvent = new CustomEvent('prompt-cancel', {
            bubbles: true,
            composed: true,
        });
        this.dispatchEvent(cancelEvent);
    }
    onDone() {
        const field = this.shadowRoot.getElementById('prompt-text-field');
        const value = field.value;
        const doneEvent = new CustomEvent('prompt-done', {
            detail: { value },
            bubbles: true,
            composed: true,
        });
        this.dispatchEvent(doneEvent);
    }
    onInput(e) {
        const value = e.target.value;
        this.isEmpty = !value.trim().length;
        const inputEvent = new CustomEvent('prompt-input', {
            detail: { value },
            bubbles: true,
            composed: true,
        });
        this.dispatchEvent(inputEvent);
    }
    render() {
        return html `
      <header class="modal-title">
        <kai-text as="h3">${this.modalTitle}</kai-text>
      </header>
      <form 
        class="modal-content"
        @submit="${e => {
            e.preventDefault();
            !this.isEmpty && this.onDone();
        }}"
      >
        <kai-input
          id="prompt-text-field"
          .value="${this.defaultValue}"
          maxlength="${this.maxLength}"
          placeholder="${this.placeholder}"
          @input-change="${this.onInput}"
          autofocus
        ></kai-input>
      </form>
      <footer class="modal-actions">
        <kai-button @click="${this.onCancel}" secondary>
          ${this.cancelLabel}
        </kai-button>
        <kai-button
          @click="${this.onDone}"
          ?disabled="${this.isEmpty}"
        >
          ${this.doneLabel}
        </kai-button>
      </footer>
    `;
    }
};
__decorate([
    property({ type: String, attribute: 'modal-title' })
], KaiPrompt.prototype, "modalTitle", void 0);
__decorate([
    property({ type: String, attribute: 'cancel-label' })
], KaiPrompt.prototype, "cancelLabel", void 0);
__decorate([
    property({ type: String, attribute: 'done-label' })
], KaiPrompt.prototype, "doneLabel", void 0);
__decorate([
    property({ type: String, attribute: 'default-value' })
], KaiPrompt.prototype, "defaultValue", void 0);
__decorate([
    property({ type: String })
], KaiPrompt.prototype, "placeholder", void 0);
__decorate([
    property({ type: Number })
], KaiPrompt.prototype, "maxLength", void 0);
__decorate([
    property({ type: Boolean, reflect: false })
], KaiPrompt.prototype, "isEmpty", void 0);
KaiPrompt = __decorate([
    customElement('kai-prompt')
], KaiPrompt);
export { KaiPrompt };
//# sourceMappingURL=kai-prompt.js.map