var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, LitElement, property, css, html } from 'lit-element';
let KaiRadio = class KaiRadio extends LitElement {
    static get styles() {
        return css `
      :host {
        display: flex;
        justify-content: center;
        align-items: center;
        width: 32px;
        height: 32px;
        background-color: transparent;
        position: relative;
      }

      .circle {
        position: absolute;
        top: 50%;
        left: 50%;
        border-radius: 50%;
      }

      #outer {
        width: 16px;
        height: 16px;
        margin-top: -8px;
        margin-left: -8px;
        z-index: 1;
      }

      #inner {
        width: 10px;
        height: 10px;
        margin-top: -5px;
        margin-left: -5px;
        background-color: var(--gs-00);
        z-index: 2;
      }

      :host(:not([checked])) #outer {
        transition-property: transform, background-color;
        transition-duration: 0.24s;
        transition-timing-function: cubic-bezier(0.3, 0, 0.25, 1);
        transform: scale(0.3);
        background-color: var(--gs-60);
      }

      :host(:not([checked])) #inner {
        transition: transform 0.24s cubic-bezier(0.3, 0, 0.25, 1);
        transform: scale(0);
      }

      :host([checked]) #outer {
        transition-property: transform, background-color;
        transition-duration: 0.4s;
        transition-timing-function: cubic-bezier(0, 0, 0.25, 1);
        transform: scale(1);
        background-color: var(--theme-color-primary);
      }

      :host([checked]) #inner {
        transition: transform 0.3s 0.06s cubic-bezier(0, 0, 0.25, 1);
        transform: scale(1);
      }
    `;
    }
    render() {
        return html `
      <div class="circle" id="inner"></div>
      <div class="circle" id="outer"></div>
    `;
    }
};
__decorate([
    property({ type: Boolean, reflect: true })
], KaiRadio.prototype, "checked", void 0);
__decorate([
    property({ type: Boolean, reflect: true })
], KaiRadio.prototype, "disabled", void 0);
__decorate([
    property({ type: String, reflect: true })
], KaiRadio.prototype, "value", void 0);
KaiRadio = __decorate([
    customElement('kai-radio')
], KaiRadio);
export { KaiRadio };
//# sourceMappingURL=kai-radio.js.map