var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, property, html, css } from 'lit-element';
import { KaiModal } from './kai-modal';
import './kai-button';
let KaiSelector = class KaiSelector extends KaiModal {
    constructor() {
        super(...arguments);
        this.values = [];
        this.handleSingleValue = (mutations) => {
            const target = mutations[0].target;
            if (target.dataset.checked === 'true') {
                this.value = target.dataset.value;
            }
        };
        this.handleMultipleValue = (mutations) => {
            const target = mutations[0].target;
            if (target.dataset.checked === 'true') {
                Array.isArray(this.value) && this.value.push(target.dataset.value);
            }
            else if (Array.isArray(this.value)) {
                const index = this.value.findIndex(value => value === target.dataset.value);
                index > -1 && this.value.splice(index, 1);
            }
        };
    }
    static get styles() {
        return [
            ...super.styles,
            css `
        .modal-content {
          text-align: center;
        }
      `,
        ];
    }
    onCancel() {
        const cancelEvent = new CustomEvent('selector-cancel', {
            bubbles: true,
            composed: true,
        });
        this.dispatchEvent(cancelEvent);
    }
    onDone() {
        const doneEvent = new CustomEvent('selector-done', {
            bubbles: true,
            composed: true,
            detail: {
                value: {
                    selected: this.type === 'single' ? this.value : this.values,
                },
            },
        });
        this.dispatchEvent(doneEvent);
    }
    firstUpdated() {
        const observerOptions = {
            childList: true,
            attributeFilter: ['data-checked'],
            subtree: true,
        };
        const callback = this.type === 'single' ? this.handleSingleValue : this.handleMultipleValue;
        const observer = new MutationObserver(callback);
        observer.observe(this, observerOptions);
    }
    updated() {
        if (this.type === 'single') {
            Array.from(this.children).forEach((item) => {
                if (item.dataset.value !== this.value.toString()) {
                    item.children.item(1).removeAttribute('checked');
                }
            });
        }
    }
    render() {
        return html `
      <header class="modal-title">
        <kai-text as="h3">${this.modalTitle}</kai-text>
      </header>
      <div class="modal-content">
        <slot></slot>
      </div>
      <footer class="modal-actions" style="text-align: center;">
        <kai-button @click="${this.onCancel}" secondary>
          ${this.cancelLabel}
        </kai-button>
        <kai-button @click="${this.onDone}">
          ${this.doneLabel}
        </kai-button>
      </footer>
    `;
    }
};
__decorate([
    property({ type: String })
], KaiSelector.prototype, "type", void 0);
__decorate([
    property({ type: String })
], KaiSelector.prototype, "value", void 0);
__decorate([
    property({ type: Array })
], KaiSelector.prototype, "values", void 0);
KaiSelector = __decorate([
    customElement('kai-selector')
], KaiSelector);
export { KaiSelector };
//# sourceMappingURL=kai-selector.js.map