var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { LitElement, customElement, property, css, html } from 'lit-element';
let KaiSidemenu = class KaiSidemenu extends LitElement {
    constructor() {
        super();
        this.open = false;
        this.addEventListener('click', this.toggle);
    }
    static get styles() {
        return css `
      :host {
        position: absolute;
        top: 0;
        left: 0;
        display: flex;
        flex-direction: row;
        justify-content: flex-start;
        width: 100%;
        height: 100%;
        pointer-events: none;
        z-index: var(--z-index-sidemenu);
      }

      nav {
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        width: 252px;
        height: 100%;
        background-color: var(--gs-20);
        box-shadow: 0.5rem 0 1.5rem 0 rgba(0, 0, 0, 0.3);
        transition-property: transform;
        transition-duration: 0.5s;
        transition-timing-function: cubic-bezier(0.75,0,1,1);
        transform: translateX(-255px);
      }

      :host([open]) {
        pointer-events: all;
      }

      :host([open]) nav {
        transition-duration: 0.45s;
        transition-timing-function: cubic-bezier(0,0,0,1);
        transform: translateX(0);
      }

      nav ::slotted(kai-button) {
        max-width: 100%;
        margin: 0;
      }
    `;
    }
    toggle() {
        this.removeAttribute('open');
    }
    render() {
        return html `<nav><slot></slot></nav>`;
    }
};
__decorate([
    property({ type: Boolean })
], KaiSidemenu.prototype, "open", void 0);
KaiSidemenu = __decorate([
    customElement('kai-sidemenu')
], KaiSidemenu);
export { KaiSidemenu };
//# sourceMappingURL=kai-sidemenu.js.map