var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { LitElement, customElement, html, css, property } from 'lit-element';
let KaiText = class KaiText extends LitElement {
    static get styles() {
        return css `
      :host {
        text-overflow: ellipsis;
        overflow: hidden;
        white-space: nowrap;
        width: 100%;
      }

      :host([as='h1']),
      :host([as='h2']),
      :host([as='h3']),
      :host([as='h4']),
      :host([as='h5']),
      :host([as='h6']) {
        font-weight: bold;
      }

      :host([as='sub-1']) {
        font-weight: 600;
        width: 100%;
      }

      :host([as='sub-2']),
      :host([as='body-1']),
      :host([as='body-2']) {
        font-weight: normal;
      }

      :host([as='h1']),
      :host([as='h4']),
      :host([as='h5']) {
        text-transform: uppercase;
      }

      :host([as='h1']) {
        font-size: calc(var(--baseline) * 4);
      }

      :host([as='h2']) {
        font-size: calc(var(--baseline) * 2.8);
      }

      :host([as='h3']) {
        font-size: calc(var(--baseline) * 2.2);
      }

      :host([as='sub-1']),
      :host([as='body-1']) {
        font-size: calc(var(--baseline) * 1.8);
      }

      :host([as='body-2']),
      :host([as='h4']) {
        font-size: calc(var(--baseline) * 1.6);
      }

      :host([as='sub-2']),
      :host([as='h5']) {
        font-size: calc(var(--baseline) * 1.4);
      }

      :host([as='h6']) {
        font-size: calc(var(--baseline) * 1.2);
      }

      :host([transform='capitalize']) {
        text-transform: capitalize;
      }

      :host([transform='lowercase']) {
        text-transform: lowercase;
      }

      :host([transform='uppercase']) {
        text-transform: uppercase;
      }

      :host([transform='none']) {
        text-transform: none;
      }
    `;
    }
    render() {
        return html `
      <slot></slot>
    `;
    }
};
__decorate([
    property({ type: String })
], KaiText.prototype, "as", void 0);
__decorate([
    property({ type: String })
], KaiText.prototype, "transform", void 0);
KaiText = __decorate([
    customElement('kai-text')
], KaiText);
export { KaiText };
//# sourceMappingURL=kai-text.js.map