var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, LitElement, property, css, html } from "lit-element";
import './kai-text';
let KaiToast = class KaiToast extends LitElement {
    constructor() {
        super(...arguments);
        this.show = false;
        this.duration = 3000;
    }
    static get styles() {
        return css `
      :host {
        position: fixed;
        top: 20px;
        left: 20px;
        width: calc(100% - 40px);
        min-height: 60px;
        background-color: var(--gs-40);
        color: var(--gs-100);
        transition-property: opacity, transform;
        transition-timing-function: cubic-bezier(0, 0, 0.25, 1);
        z-index: var(--z-index-toast);
        pointer-events: none;
        text-align: center;
        padding: 20px;
        border-radius: 30px;
        box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.3);
        white-space: normal;
      }

      :host(:not([show])) {
        transition-delay: 0, 0.12s;
        transition-duration: 0.12s, 0.01;
        opacity: 0;
        transform: translateY(10px);
      }

      :host([show]) {
        transition-duration: 0.15s, 0.3s;
        opacity: 1;
        transform: translateY(0);
      }
    `;
    }
    updated() {
        if (this.show) {
            setTimeout(() => {
                this.show = false;
                this.duration = null;
            }, this.duration);
        }
    }
    render() {
        return html `<kai-text as="sub-1" style="white-space: normal;"><slot></slot></kai-text>`;
    }
};
__decorate([
    property({ type: Boolean, reflect: true, attribute: true })
], KaiToast.prototype, "show", void 0);
__decorate([
    property({ type: Number, reflect: true, attribute: true })
], KaiToast.prototype, "duration", void 0);
KaiToast = __decorate([
    customElement('kai-toast')
], KaiToast);
export { KaiToast };
//# sourceMappingURL=kai-toast.js.map