var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { customElement, LitElement, property, css, html } from "lit-element";
let KaiToggle = class KaiToggle extends LitElement {
    constructor() {
        super(...arguments);
        this.checked = false;
        this.disabled = false;
        this.interaction = (e) => {
            this.checked = !this.checked;
        };
    }
    static get styles() {
        return css `
      :host {
        display: flex;
        justify-content: center;
        align-items: center;
        width: 32px;
        height: 32px;
        background-color: transparent;
        position: relative;
      }

      .track {
        position: absolute;
        top: 4px;
        left: 15px;
        width: 2px;
        height: 24px;
        border-radius: 2px;
        z-index: 1;
      }

      .outer-circle {
        position: absolute;
        left: 8px;
        width: 16px;
        height: 16px;
        border-radius: 50%;
        z-index: 2;
        transition-property: bottom;
        transition-timing-function: cubic-bezier(0.3, 0, 0, 1);
      }

      .inner-circle {
        position: absolute;
        top: 50%;
        left: 50%;
        width: 10px;
        height: 10px;
        margin-top: -5px;
        margin-left: -5px;
        background-color: var(--gs-00);
        border-radius: 50%;
        transition-property: transform;
      }

      :host(:not([checked])) .track,
      :host(:not([checked])) .outer-circle {
        background-color: var(--gs-60);
      }

      :host(:not([checked])) .outer-circle {
        transition-duration: 0.3s;
        bottom: 4px;
      }

      :host(:not([checked])) .inner-circle {
        transition-duration: 0.3s;
        transform: scale(1);
      }

      :host([checked]) .track,
      :host([checked]) .outer-circle {
        background-color: var(--theme-color-primary);
      }

      :host([checked]) .outer-circle {
        transition-duration: 0.36s;
        bottom: 12px;
      }

      :host([checked]) .inner-circle {
        transition-duration: 0.36s;
        transform: scale(0);
      }
    `;
    }
    customEvent() {
        return new CustomEvent(`toggle-change`, {
            bubbles: true,
            composed: true,
            cancelable: false,
            detail: {
                checked: this.checked,
                disabled: this.disabled
            }
        });
    }
    firstUpdated() {
        this.addEventListener('touchstart', this.interaction);
    }
    updated() {
        this.dispatchEvent(this.customEvent());
    }
    render() {
        return html `
      <div class="track"></div>
      <div class="outer-circle">
        <div class="inner-circle"></div>
      </div>
    `;
    }
};
__decorate([
    property({ type: Boolean, reflect: true })
], KaiToggle.prototype, "checked", void 0);
__decorate([
    property({ type: Boolean, reflect: true })
], KaiToggle.prototype, "disabled", void 0);
KaiToggle = __decorate([
    customElement('kai-toggle')
], KaiToggle);
export { KaiToggle };
//# sourceMappingURL=kai-toggle.js.map